package jp.co.veritrans.vtweb.mdk.bean;

import java.util.HashMap;
import java.util.Map;

/**
 * 3G-Webからの受信情報を保持するクラス
 */
public final class PostDataBox {

    /**
     * 自身のクラス
     */
    private static PostDataBox keyBox = new PostDataBox();

    /**
     * 暗号鍵を格納するマップ
     */
    private Map box = new HashMap();

    /**
     * 外部からインスタンス生成を禁止する
     *
     */
    private PostDataBox() {
    }

    /**
     * インスタンスを返す
     * @return インスタンス
     */
    public static PostDataBox getInstance() {
        return keyBox;
    }

    /**
     * 暗号鍵を設定する
     * @param key オーダーID
     * @param databox 暗号鍵を格納したマップ
     */
    public void setBox(String key, Map databox) {
        box.put(key, databox);
    }

    /**
     * 暗号鍵を取得する
     * @param key オーダーID
     * @return 暗号鍵を格納したマップ
     */
    public Map getBox(String key) {
        return (Map) box.get(key);
    }

    /**
     * 暗号鍵を格納したマップを取得する
     * @return 暗号鍵を格納したマップ
     */
    public Map getBox() {
        return box;
    }

}