package jp.co.veritrans.vtweb.mdk.common;

/**
 * デフォルト値を保持するクラス
 */
public class Constants {

    /**
     * VT Webの文字コード
     */
    public static final String VTW_ENCODE = "UTF-8";

    /**
     * 日付変換パターン。誕生日の形式変換時に使用
     */
    public static final String DATE_PATTERN_YYYYMMDD = "yyyyMMdd";

    /**
     * 決済種別：カード
     */
    public static final String SETTLEMENT_TYPE_CARD = "01";

    /**
     * 決済種別：コンビニ
     */
    public static final String SETTLEMENT_TYPE_CVS = "02";

    /**
     * 決済種別：電子マネー
     */
    public static final String SETTLEMENT_TYPE_EM = "03";

    /**
     * 決済種別：銀行
     */
    public static final String SETTLEMENT_TYPE_BANK = "04";

    /**
     * 決済種別：ショッピングクレジット
     */
    public static final String SETTLEMENT_TYPE_ORICOSC = "05";

    /**
     * 決済種別：銀行振込決済
     */
    public static final String SETTLEMENT_TYPE_VA = "06";

    /**
     * デフォルト支払取消期限
     */
    public static final int DEFAULT_CANCEL_LIMIT_DAYS = 60;

    /*******************************************************/
    /*                                                     */
    /* CVS CONSTANTS */
    /*                                                     */
    /*******************************************************/

    /**
     * コンビニ決済オプション：セブンイレブン
     */
    public static final String CVS_SUBTYPE_711 = "201";

    /**
     * コンビニ決済オプション：イーコン
     */
    public static final String CVS_SUBTYPE_ECON = "205";

    /**
     * コンビニ決済オプション：その他
     */
    public static final String CVS_SUBTYPE_OTHER = "204";

    /*******************************************************/
    /*                                                     */
    /* EM CONSTANTS */
    /*                                                     */
    /*******************************************************/

    /**
     * 電子マネー決済オプション:サイバーEdy
     */
    public static final String EM_SUBTYPE_EDY_PC = "311";

    /**
     * 電子マネー決済オプション:モバイルEdy
     */
    public static final String EM_SUBTYPE_EDY_MOBILE = "312";

    /**
     * 電子マネー決済オプション:Suicaインターネットサービス。
     */
    public static final String EM_SUBTYPE_SUICA_PC = "321";

    /**
     * 電子マネー決済オプション:モバイルSuica。
     */
    public static final String EM_SUBTYPE_SUICA_MOBILE = "322";

    /**
     * 電子マネー決済オプション:WAON（Pasori）
     */
    public static final String EM_SUBTYPE_WAON_PC = "331";

    /**
     * 電子マネー決済オプション:モバイルWAON
     */
    public static final String EM_SUBTYPE_WAON_MOBILE = "332";

    /*******************************************************/
    /*                                                     */
    /* BANK CONSTANTS */
    /*                                                     */
    /*******************************************************/
    /**
     * ATM決済(番号通知方式)
     */
    public static final String BANK_SUBTYPE_ATM = "411";

    /**
     * ネットバンク決済
     */
    public static final String BANK_SUBTYPE_NETBANK = "420";

    /*******************************************************/
    /*                                                     */
    /* VT Web Results */
    /*                                                     */
    /*******************************************************/

    /**
     * 取引IDの取得キー
     */
    public static final String VTWRES_ORDER_ID = "orderId";

    /**
     *  ステータスの取得キー
     */
    public static final String VTWRES_M_STATUS = "mStatus";

    /**
     * エラーメッセージの取得キー
     */
    public static final String VTWRES_M_ERR_MSG = "mErrMsg";

    /**
     * 結果コードの取得キー
     */
    public static final String VTWRES_V_RESULT_CODE = "vResultCode";

    /**
     * 漢字氏名の取得キー
     */
    public static final String VTWRES_USER_NAME = "userName";

    /**
     * カナ氏名の取得キー
     */
    public static final String VTWRES_USER_NAME_KANA = "userNameKana";

    /**
     * 電話番号の取得キー
     */
    public static final String VTWRES_TELEPHONE_NO = "telephoneno";


    /**
     * sessionIdの取得キー
     */
    public static final String VTWRES_SESSION_ID = "sessionId";

    /**
     * 受付番号の取得キー
     */
    public static final String VTWRES_RECEIPT_NO = "receiptNo";

    /**
     * マーチャント暗号鍵の取得キー
     */
    public static final String VTWRES_SETTLEMENTKEY1B = "SETTLEMENTKEY1B";
}
