package jp.co.veritrans.vtweb.mdk.common;

import java.util.Map;

import jp.co.veritrans.vtweb.mdk.bean.ResultDataBean;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import jp.co.veritrans.vtweb.sample.server.action.DoPostForm;

import org.apache.log4j.Logger;

/**
 * 決済結果のチェックを行うクラス
 */
public class ResultCheck {

    /**
     * ログ出力用インスタンス
     */
    private Logger log = Logger.getLogger(ResultCheck.class);

    /**
     * VTWからのRequestの内容確認
     *
     * @param databean VTWからの情報
     * @return 正しい場合true 正しくない場合false
     */
    public boolean resultCheck(ResultDataBean databean) {
        boolean checkflag;

        // どれか一つでもnullがあったらエラー
        if (databean.getOrderId() == null || databean.getOrderId().equals("null")) {
            checkflag = false;
        } else if (databean.getmStatus() == null || databean.getmStatus().equals("null")) {
            checkflag = false;
        } else if (databean.getvResultCode() == null || databean.getvResultCode().equals("null")) {
            checkflag = false;
        } else {
            checkflag = true;
            log.info("リクエストにnullはなし");
        }

        return checkflag;
    }

    /**
     * VWT側とブラウザ側の整合性チェック
     *
     * @param commForm DoPostForm
     * @return 整合性の成否
     */
    public boolean resultCrossCheck(DoPostForm commForm) {
        if (log.isInfoEnabled()) {
            log.info("stored orderId=" + commForm.getOrderIdVtw());
            log.info("stored mStatus=" + commForm.getmStatusVtw());
            log.info("stored vResultCode=" + commForm.getvResultCodeVtw());
        }

        boolean verifyOrderId = isMatchStr(commForm.getOrderId(), commForm.getOrderIdVtw());
        commForm.setVerifyOrderId(verifyOrderId);
        boolean verifyMStatus = isMatchStr(commForm.getmStatus(), commForm.getmStatusVtw());
        commForm.setVerifyMStatus(verifyMStatus);
        boolean verifyVResultCode = isMatchStr(commForm.getvResultCode(), commForm.getvResultCodeVtw());
        commForm.setVerifyVResultCode(verifyVResultCode);

        return verifyOrderId && verifyMStatus && verifyVResultCode;
    }

    /**
     * 2つの文字列が一致しているかどうか比較
     * ※互いにnullの場合は false とする
     *
     * @param str1 比較対象1
     * @param str2 比較対象2
     * return result 結果
     */
    private boolean isMatchStr(String str1, String str2) {
        boolean result = false;
        if (str1 != null && str1.equals(str2)) {
            result = true;
        }
        return result;
    }
}
