package jp.co.veritrans.vtweb.sample.server.action;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import jp.co.veritrans.vtweb.mdk.common.MDKUtils;
import jp.co.veritrans.vtweb.mdk.common.StringUtil;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

/**
 * 決済情報のActionFormクラス
 */
public class CommodityForm extends ActionForm {

    /**
     * serial version UID.
     */
    private static final long serialVersionUID = -7381901876252825928L;

    /**
     * ログ出力用インスタンス
     */
    private static Logger log = Logger.getLogger(CommodityForm.class);

    /** PayNowID使用フラグ */
    private boolean paynowidFlag;

    /** 会員ID */
    private String accountId;

    /** 注文番号 */
    private String oricoOrderNo = "";

    /** 送料合計 */
    private String shippingAmount = "";

    /** 商品合計金額 */
    private String commodityAmount = "";

    /** 配送先郵便番号(先頭3桁) */
    private String shippingZipCode1 = "";

    /** 配送先郵便番号(末尾4桁) */
    private String shippingZipCode2 = "";

    /** 決済方法 */
    private String settlementType = "";

    /** 決済方法サブタイプ */
    private String settlementSubType = "";

    /** マーチャントID */
    private String merchantId = "";

    /** 取引ID */
    private String orderId = "";

    /** SessionID */
    private String sessionId = "";

    /** 購入金額 */
    private String amount = "";

    /** カード売上フラグ */
    private String cardCaptureFlag = "";

    /** モバイルEdy用ショップ名 */
    private String shopName = "";

    /** Suica用商品名 */
    private String screenTitle = "";

    /** 請求内容 */
    private String contents = "";

    /** 請求内容カナ */
    private String contentsKana = "";

    /** 支払取消期限 */
    private String timelimitOfCancel = "";

    /** マーチャント生成ハッシュ値 */
    private String merchanthash = "";

    /** 決済完了後戻りURL */
    private String finishPaymentReturnUrl = "";

    /** 未決済時戻りURL */
    private String unfinishPaymentReturnUrl = "";

    /** 決済エラー時戻りURL */
    private String errorPaymentReturnUrl = "";

    /** 決済結果通知先URL */
    private String finishPaymentAccessUrl = "";

    /** 言語選択可否フラグ */
    private String langEnableFlag = "";

    /** 使用言語 */
    private String lang = "";

    /** ダミー決済フラグ */
    private String dummyPaymentFlag = "";

    /** 商品ID */
    private String[] commodityId;

    /** 単価 */
    private String[] commodityUnit;

    /** 個数 */
    private String[] commodityNum;

    /** 商品名 */
    private String[] commodityName;

    /** JANコード */
    private String[] commodityJanCode;

    /** 登録時振込番号 */
    private String entryTransferNumber = "";

    /** 登録時振込番号 */
    private String transferExpiredDate = "";

    /** 口座管理方式 */
    private String accountManageType = "0";

    /** 支店コード */
    private String branchCode = "";

    /** 口座番号 */
    private String accountNumber = "";

    /** 銀行口座関連付け拒否フラグ */
    private boolean rejectBankAccount;

    /**
     * @return the paynowidFlag
     */
    public boolean isPaynowidFlag() {
        return paynowidFlag;
    }

    /**
     * @param paynowidFlag the paynowidFlag to set
     */
    public void setPaynowidFlag(final boolean paynowidFlag) {
        this.paynowidFlag = paynowidFlag;
    }

    /**
     * @return the accountId
     */
    public String getAccountId() {
        return accountId;
    }

    /**
     * @param accountId the accountId to set
     */
    public void setAccountId(final String accountId) {
        this.accountId = accountId;
    }

    /**
     * 配送先郵便番号の取得
     *
     * @return 配送先郵便番号
     */
    public String getShippingZipCode() {
        return StringUtil.emptyString(shippingZipCode1) + StringUtil.emptyString(shippingZipCode2);
    }

    /**
     * oricoOrderNoの取得
     *
     * @return the oricoOrderNo of String
     */
    public String getOricoOrderNo() {
        return oricoOrderNo;
    }

    /**
     * oricoOrderNoの設定
     *
     * @param oricoOrderNo the oricoscOrderNo to set
     */
    public void setOricoOrderNo(final String oricoOrderNo) {
        this.oricoOrderNo = oricoOrderNo;
    }

    /**
     * shippingAmountの取得
     *
     * @return the shippingAmount of String
     */
    public String getShippingAmount() {
        return shippingAmount;
    }

    /**
     * shippingAmountの設定
     *
     * @param shippingAmount the shippingAmount to set
     */
    public void setShippingAmount(final String shippingAmount) {
        this.shippingAmount = shippingAmount;
    }

    /**
     * commodityAmountの取得
     *
     * @return the commodityAmount of String
     */
    public String getCommodityAmount() {
        return commodityAmount;
    }

    /**
     * commodityAmountの設定
     *
     * @param commodityAmount the commodityAmount to set
     */
    public void setCommodityAmount(final String commodityAmount) {
        this.commodityAmount = commodityAmount;
    }

    /**
     * shippingZipCode1の取得
     *
     * @return the shippingZipCode1 of String
     */
    public String getShippingZipCode1() {
        return shippingZipCode1;
    }

    /**
     * shippingZipCode1の設定
     *
     * @param shippingZipCode1 the shippingZipCode1 to set
     */
    public void setShippingZipCode1(final String shippingZipCode1) {
        this.shippingZipCode1 = shippingZipCode1;
    }

    /**
     * shippingZipCode2の取得
     *
     * @return the shippingZipCode2 of String
     */
    public String getShippingZipCode2() {
        return shippingZipCode2;
    }

    /**
     * shippingZipCode2の設定
     *
     * @param shippingZipCode2 the shippingZipCode2 to set
     */
    public void setShippingZipCode2(final String shippingZipCode2) {
        this.shippingZipCode2 = shippingZipCode2;
    }

    /**
     * settlementTypeの取得
     *
     * @return the settlementType of String
     */
    public String getSettlementType() {
        return settlementType;
    }

    /**
     * settlementTypeの設定
     *
     * @param settlementType the settlementType to set
     */
    public void setSettlementType(final String settlementType) {
        this.settlementType = settlementType;
    }

    /**
     * settlementSubTypeの取得
     *
     * @return the settlementSubType of String
     */
    public String getSettlementSubType() {
        return settlementSubType;
    }

    /**
     * settlementSubTypeの設定
     *
     * @param settlementSubType the settlementSubType to set
     */
    public void setSettlementSubType(final String settlementSubType) {
        this.settlementSubType = settlementSubType;
    }

    /**
     * merchantIdの取得
     *
     * @return the merchantId of String
     */
    public String getMerchantId() {
        return merchantId;
    }

    /**
     * merchantIdの設定
     *
     * @param merchantId the merchantId to set
     */
    public void setMerchantId(final String merchantId) {
        this.merchantId = merchantId;
    }

    /**
     * orderIdの取得
     *
     * @return the orderId of String
     */
    public String getOrderId() {
        return orderId;
    }

    /**
     * orderIdの設定
     *
     * @param orderId the orderId to set
     */
    public void setOrderId(final String orderId) {
        this.orderId = orderId;
    }

    /**
     * sessionIdの取得
     *
     * @return the sessionId of String
     */
    public String getSessionId() {
        return sessionId;
    }

    /**
     * sessionIdの設定
     *
     * @param sessionId the sessionId to set
     */
    public void setSessionId(final String sessionId) {
        this.sessionId = sessionId;
    }

    /**
     * amountの取得
     *
     * @return the amount of String
     */
    public String getAmount() {
        return amount;
    }

    /**
     * amountの設定
     *
     * @param amount the amount to set
     */
    public void setAmount(final String amount) {
        this.amount = amount;
    }

    /**
     * cardCaptureFlagの取得
     *
     * @return the cardCaptureFlag of String
     */
    public String getCardCaptureFlag() {
        return cardCaptureFlag;
    }

    /**
     * cardCaptureFlagの設定
     *
     * @param cardCaptureFlag the cardCaptureFlag to set
     */
    public void setCardCaptureFlag(final String cardCaptureFlag) {
        this.cardCaptureFlag = cardCaptureFlag;
    }

    /**
     * shopNameの取得
     *
     * @return the shopName of String
     */
    public String getShopName() {
        return shopName;
    }

    /**
     * shopNameの設定
     *
     * @param shopName the shopName to set
     */
    public void setShopName(final String shopName) {
        this.shopName = shopName;
    }

    /**
     * screenTitleの取得
     *
     * @return the screenTitle of String
     */
    public String getScreenTitle() {
        return screenTitle;
    }

    /**
     * screenTitleの設定
     *
     * @param screenTitle the screenTitle to set
     */
    public void setScreenTitle(final String screenTitle) {
        this.screenTitle = screenTitle;
    }

    /**
     * contentsの取得
     *
     * @return the contents of String
     */
    public String getContents() {
        return contents;
    }

    /**
     * contentsの設定
     *
     * @param contents the contents to set
     */
    public void setContents(final String contents) {
        this.contents = contents;
    }

    /**
     * contentsKanaの取得
     *
     * @return the contentsKana of String
     */
    public String getContentsKana() {
        return contentsKana;
    }

    /**
     * contentsKanaの設定
     *
     * @param contentsKana the contentsKana to set
     */
    public void setContentsKana(final String contentsKana) {
        this.contentsKana = contentsKana;
    }

    /**
     * timelimitOfCancelの取得
     *
     * @return the timelimitOfCancel of String
     */
    public String getTimelimitOfCancel() {
        return timelimitOfCancel;
    }

    /**
     * timelimitOfCancelの設定
     *
     * @param timelimitOfCancel the timelimitOfCancel to set
     */
    public void setTimelimitOfCancel(final String timelimitOfCancel) {
        this.timelimitOfCancel = timelimitOfCancel;
    }

    /**
     * merchanthashの取得
     *
     * @return the merchanthash of String
     */
    public String getMerchanthash() {
        return merchanthash;
    }

    /**
     * merchanthashの設定
     *
     * @param merchanthash the merchanthash to set
     */
    public void setMerchanthash(final String merchanthash) {
        this.merchanthash = merchanthash;
    }

    /**
     * finishPaymentReturnUrlの取得
     *
     * @return the finishPaymentReturnUrl of String
     */
    public String getFinishPaymentReturnUrl() {
        return finishPaymentReturnUrl;
    }

    /**
     * finishPaymentReturnUrlの設定
     *
     * @param finishPaymentReturnUrl the finishPaymentReturnUrl to set
     */
    public void setFinishPaymentReturnUrl(final String finishPaymentReturnUrl) {
        this.finishPaymentReturnUrl = finishPaymentReturnUrl;
    }

    /**
     * unfinishPaymentReturnUrlの取得
     *
     * @return the unfinishPaymentReturnUrl of String
     */
    public String getUnfinishPaymentReturnUrl() {
        return unfinishPaymentReturnUrl;
    }

    /**
     * unfinishPaymentReturnUrlの設定
     *
     * @param unfinishPaymentReturnUrl the unfinishPaymentReturnUrl to set
     */
    public void setUnfinishPaymentReturnUrl(final String unfinishPaymentReturnUrl) {
        this.unfinishPaymentReturnUrl = unfinishPaymentReturnUrl;
    }

    /**
     * errorPaymentReturnUrlの取得
     *
     * @return the errorPaymentReturnUrl of String
     */
    public String getErrorPaymentReturnUrl() {
        return errorPaymentReturnUrl;
    }

    /**
     * errorPaymentReturnUrlの設定
     *
     * @param errorPaymentReturnUrl the errorPaymentReturnUrl to set
     */
    public void setErrorPaymentReturnUrl(final String errorPaymentReturnUrl) {
        this.errorPaymentReturnUrl = errorPaymentReturnUrl;
    }

    /**
     * finishPaymentAccessUrlの取得
     *
     * @return the finishPaymentAccessUrl of String
     */
    public String getFinishPaymentAccessUrl() {
        return finishPaymentAccessUrl;
    }

    /**
     * finishPaymentAccessUrlの設定
     *
     * @param finishPaymentAccessUrl the finishPaymentAccessUrl to set
     */
    public void setFinishPaymentAccessUrl(final String finishPaymentAccessUrl) {
        this.finishPaymentAccessUrl = finishPaymentAccessUrl;
    }

    /**
     * langEnableFlagの取得
     *
     * @return the langEnableFlag of String
     */
    public String getLangEnableFlag() {
        return langEnableFlag;
    }

    /**
     * langEnableFlagの設定
     *
     * @param langEnableFlag the langEnableFlag to set
     */
    public void setLangEnableFlag(final String langEnableFlag) {
        this.langEnableFlag = langEnableFlag;
    }

    /**
     * langの取得
     *
     * @return the lang of String
     */
    public String getLang() {
        return lang;
    }

    /**
     * langの設定
     *
     * @param lang the lang to set
     */
    public void setLang(final String lang) {
        this.lang = lang;
    }

    /**
     * dummyPaymentFlagの取得
     *
     * @return the dummyPaymentFlag of String
     */
    public String getDummyPaymentFlag() {
        return dummyPaymentFlag;
    }

    /**
     * dummyPaymentFlagの設定
     *
     * @param dummyPaymentFlag the dummyPaymentFlag to set
     */
    public void setDummyPaymentFlag(final String dummyPaymentFlag) {
        this.dummyPaymentFlag = dummyPaymentFlag;
    }

    /**
     * commodityIdの取得
     *
     * @return the commodityId of String[]
     */
    public String[] getCommodityId() {
        return commodityId;
    }

    /**
     * commodityIdの設定
     *
     * @param commodityId the commodityId to set
     */
    public void setCommodityId(final String[] commodityId) {
        this.commodityId = commodityId;
    }

    /**
     * commodityUnitの取得
     *
     * @return the commodityUnit of String[]
     */
    public String[] getCommodityUnit() {
        return commodityUnit;
    }

    /**
     * commodityUnitの設定
     *
     * @param commodityUnit the commodityUnit to set
     */
    public void setCommodityUnit(final String[] commodityUnit) {
        this.commodityUnit = commodityUnit;
    }

    /**
     * commodityNumの取得
     *
     * @return the commodityNum of String[]
     */
    public String[] getCommodityNum() {
        return commodityNum;
    }

    /**
     * commodityNumの設定
     *
     * @param commodityNum the commodityNum to set
     */
    public void setCommodityNum(final String[] commodityNum) {
        this.commodityNum = commodityNum;
    }

    /**
     * commodityNameの取得
     *
     * @return the commodityName of String[]
     */
    public String[] getCommodityName() {
        return commodityName;
    }

    /**
     * commodityNameの設定
     *
     * @param commodityName the commodityName to set
     */
    public void setCommodityName(final String[] commodityName) {
        this.commodityName = commodityName;
    }

    /**
     * commodityJanCodeの取得
     *
     * @return the commodityJanCode of String[]
     */
    public String[] getCommodityJanCode() {
        return commodityJanCode;
    }

    /**
     * commodityJanCodeの設定
     *
     * @param commodityJanCode the commodityJanCode to set
     */
    public void setCommodityJanCode(final String[] commodityJanCode) {
        this.commodityJanCode = commodityJanCode;
    }

    /**
     * @return the entryTransferNumber
     */
    public String getEntryTransferNumber() {
        return entryTransferNumber;
    }

    /**
     * @param entryTransferNumber the entryTransferNumber to set
     */
    public void setEntryTransferNumber(final String entryTransferNumber) {
        this.entryTransferNumber = entryTransferNumber;
    }

    /**
     * @return the transferExpiredDate
     */
    public String getTransferExpiredDate() {
        return transferExpiredDate;
    }

    /**
     * @param transferExpiredDate the transferExpiredDate to set
     */
    public void setTransferExpiredDate(final String transferExpiredDate) {
        this.transferExpiredDate = transferExpiredDate;
    }

    /**
     * @return the accountManageType
     */
    public String getAccountManageType() {
        return accountManageType;
    }

    /**
     * @param accountManageType the accountManageType to set
     */
    public void setAccountManageType(final String accountManageType) {
        this.accountManageType = accountManageType;
    }

    /**
     * @return the branchCode
     */
    public String getBranchCode() {
        return branchCode;
    }

    /**
     * @param branchCode the branchCode to set
     */
    public void setBranchCode(final String branchCode) {
        this.branchCode = branchCode;
    }

    /**
     * @return the accountNumber
     */
    public String getAccountNumber() {
        return accountNumber;
    }

    /**
     * @param accountNumber the accountNumber to set
     */
    public void setAccountNumber(final String accountNumber) {
        this.accountNumber = accountNumber;
    }

    /**
     * @return the rejectBankAccount
     */
    public boolean isRejectBankAccount() {
        return rejectBankAccount;
    }

    /**
     * @param rejectBankAccount the rejectBankAccount to set
     */
    public void setRejectBankAccount(final boolean rejectBankAccount) {
        this.rejectBankAccount = rejectBankAccount;
    }

    /**
     * エラーチェック
     *
     * @param mapping このインスタンスを選択するために使用するマッピング
     * @param request 処理中のHTTPリクエスト
     * @return エラーメッセージ
     */
    @Override
    public ActionErrors validate(final ActionMapping mapping, final HttpServletRequest request) {
        ActionErrors errors = new ActionErrors();
        return validate(mapping, request, errors);
    }

    /**
     * エラーチェック
     *
     * @param mapping このインスタンスを選択するために使用するマッピング
     * @param request 処理中のHTTPリクエスト
     * @param errors エラー格納インスタンス
     * @return エラーメッセージ
     */
    public ActionErrors validate(final ActionMapping mapping, final HttpServletRequest request,
            final ActionErrors errors) {
        log.info("入力情報をチェックします");

        if (isPaynowidFlag()&& StringUtil.isNullStr(getAccountId())){
            addError(errors, "error.accountId.invalid");
        }

        // 配送先郵便番号
        if (!StringUtil.isNullStr(getShippingZipCode())
                && !getShippingZipCode().equals(StringUtil.removeNonNumber(getShippingZipCode()))) {
            addError(errors, "error.shippingZipCode.forbiddenchar");
        }
        // 送料合計
        if (!StringUtil.isNullStr(getShippingAmount())) {
            if (!StringUtil.isNumeric(getShippingAmount())) {
                addError(errors, "error.cardHolderName.invalid");
            }
        }

        // 商品情報
        if (MDKUtils.isEmptyArray(getCommodityName())) {
            if (!MDKUtils.isEmptyArray(getCommodityId()) || !MDKUtils.isEmptyArray(getCommodityJanCode())
                    || !MDKUtils.isEmptyArray(getCommodityNum()) || !MDKUtils.isEmptyArray(getCommodityUnit())) {
                // 商品名に入力がない場合は商品情報は入力不可
                logCommodityInfo();
                addError(errors, "error.commodityinfo.invalid");
            }
        } else {
            int commoditySize = getCommodityName().length;
            if (MDKUtils.isEmptyArray(getCommodityNum()) || getCommodityNum().length != commoditySize
                    || MDKUtils.isEmptyArray(getCommodityUnit()) || getCommodityUnit().length != commoditySize
                    || !MDKUtils.isEmptyArray(getCommodityId()) && getCommodityId().length != commoditySize
                    || !MDKUtils.isEmptyArray(getCommodityJanCode()) && getCommodityJanCode().length != commoditySize) {
                // 商品名の入力数と個数、単価の入力数は一致していければならない
                // 商品IDとJAN_CODEは入力必須ではないが、入力している場合は商品名の入力数と一致していなければならない
                logCommodityInfo();
                addError(errors, "error.commodityinfo.unnmatch");
            } else {
                for (int i = 0; i < commoditySize; i++) {
                    if (!StringUtil.isNumeric(getCommodityNum()[i]) || !StringUtil.isNumeric(getCommodityUnit()[i])) {
                        // 単価と個数は数値項目でなければならない
                        logCommodityInfo();
                        addError(errors, "error.commodityinfo.notnumeric");
                    }
                }
            }
        }
        return errors;
    }

    /**
     * 商品情報をログ出力する。
     */
    protected void logCommodityInfo() {
        if (!MDKUtils.isEmptyArray(getCommodityId())) {
            for (int i = 0; i < getCommodityId().length; i++) {
                log.warn("COMMODITY_ID[" + i + "] = " + getCommodityId()[i]);
            }
        } else {
            log.warn("COMMODITY_ID is Empty");
        }

        if (!MDKUtils.isEmptyArray(getCommodityUnit())) {
            for (int i = 0; i < getCommodityUnit().length; i++) {
                log.warn("COMMODITY_UNIT[" + i + "] = " + getCommodityUnit()[i]);
            }
        } else {
            log.warn("COMMODITY_UNIT is Empty");
        }

        if (!MDKUtils.isEmptyArray(getCommodityNum())) {
            for (int i = 0; i < getCommodityNum().length; i++) {
                log.warn("COMMODITY_NUM[" + i + "] = " + getCommodityNum()[i]);
            }
        } else {
            log.warn("COMMODITY_NUM is Empty");
        }

        if (!MDKUtils.isEmptyArray(getCommodityName())) {
            for (int i = 0; i < getCommodityName().length; i++) {
                log.warn("COMMODITY_NAME[" + i + "] = " + getCommodityName()[i]);
            }
        } else {
            log.warn("COMMODITY_NAME is Empty");
        }

        if (!MDKUtils.isEmptyArray(getCommodityJanCode())) {
            for (int i = 0; i < getCommodityJanCode().length; i++) {
                log.warn("JAN_CODE[" + i + "] = " + getCommodityJanCode()[i]);
            }
        } else {
            log.warn("JAN_CODE is Empty");
        }
    }

    /**
     * エラーメッセージ登録メソッド
     *
     * @param errors ActionErrorsインスタンス
     * @param errorMsgId エラー文言ID
     */
    protected void addError(final ActionErrors errors, final String errorMsgId) {
        errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(errorMsgId));
    }
}
