package jp.co.veritrans.vtweb.sample.server.action;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.veritrans.vtweb.mdk.bean.PostDataBox;
import jp.co.veritrans.vtweb.mdk.bean.ResultDataBean;
import jp.co.veritrans.vtweb.mdk.common.ResultCheck;
import jp.co.veritrans.vtweb.mdk.common.Constants;
import jp.co.veritrans.vtweb.mdk.common.StringUtil;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * ブラウザからの決済結果を受け取り、比較する処理のActionクラス
 */
public class DoPostActionBrowser extends Action {

    /**
     * ログ出力用インスタンス
     */
    private Logger log = Logger.getLogger(DoPostActionBrowser.class);

    /**
     * リクエストを処理してレスポンスを返すメソッド
     *
     * @param mapping このインスタンスを選択するために使用するマッピング
     * @param form このリクエストのためのアクションフォーム
     * @param request 処理中のHTTPリクエスト
     * @param response 生成するHTTPレスポンス
     * @return 次のJSPのマッピング情報
     */
    public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request,
            HttpServletResponse response) {
        log.info("決済結果整合性確認開始");

        ResultDataBean databean = new ResultDataBean();
        DoPostForm commForm = (DoPostForm) form;

        if(log.isInfoEnabled()){
            log.info("orderId="+commForm.getOrderId());
            log.info("mStatus="+commForm.getmStatus());
            log.info("vResultCode="+commForm.getvResultCode());
        }

        // 消費者ブラウザからのデータをセットする
        databean.setOrderId(commForm.getOrderId());
        databean.setmStatus(commForm.getmStatus());
        databean.setvResultCode(commForm.getvResultCode());

        PostDataBox dataBox = PostDataBox.getInstance();
        Map box = dataBox.getBox(commForm.getOrderId());
        if(box != null){
            // vtw通知のデータをセットする
            commForm.setOrderIdVtw(commForm.getOrderId());
            commForm.setmStatusVtw(StringUtil.emptyString((String) box.get(Constants.VTWRES_M_STATUS)));
            commForm.setvResultCodeVtw(StringUtil.emptyString((String) box.get(Constants.VTWRES_V_RESULT_CODE)));
        } else {
            log.info("取引IDに該当する結果が有りません:orderId=" + commForm.getOrderId());
        }

        // 消費者ブラウザからのデータとvtw通知のデータを比較する
        ResultCheck rcheck = new ResultCheck();
        boolean result = rcheck.resultCrossCheck(commForm);
        commForm.setVerifyError(result);

        return mapping.findForward("finish");

    }
}
