package jp.co.veritrans.vtweb.sample.server.action;

import org.apache.struts.action.ActionForm;

/**
 * ブラウザからの決済結果を受け取り、比較する処理のActionFormクラス
 */
public class DoPostForm extends ActionForm {

    /** serial version UID. */
    private static final long serialVersionUID = 8664728883149660895L;

    /** 取引ID(消費者ブラウザから) */
    private String orderId;
    /** ステータス(消費者ブラウザから) */
    private String mStatus;
    /** 結果コード(消費者ブラウザから) */
    private String vResultCode;

    /** 取引ID(vtw通知) */
    private String orderIdVtw;
    /** ステータス(vtw通知) */
    private String mStatusVtw;
    /** 結果コード(vtw通知) */
    private String vResultCodeVtw;

    /** 消費者ブラウザからのものとvtw通知の取引IDが一致するか */
    private boolean verifyOrderId;
    /** 消費者ブラウザからのものとvtw通知のステータスが一致するか */
    private boolean verifyMStatus;
    /** 消費者ブラウザからのものとvtw通知のセッションIDが一致するか */
    private boolean verifyVResultCode;
    /** エラー */
    private boolean verifyError;

    /**
     * コンストラクタ
     */
    public DoPostForm(){
        super();
    }

    /**
     * orderIdの取得
     * @return the orderId of String
     */
    public String getOrderId() {
        return orderId;
    }

    /**
     * orderIdの設定
     * @param orderId the orderId to set
     */
    public void setOrderId(String orderId) {
        this.orderId = orderId;
    }

    /**
     * mStatusの取得
     * @return the mStatus of String
     */
    public String getmStatus() {
        return mStatus;
    }

    /**
     * mStatusの設定
     * @param mStatus the mStatus to set
     */
    public void setmStatus(String mStatus) {
        this.mStatus = mStatus;
    }

    /**
     * vResultCodeの取得
     * @return the vResultCode of String
     */
    public String getvResultCode() {
        return vResultCode;
    }

    /**
     * vResultCodeの設定
     * @param vResultCode the vResultCode to set
     */
    public void setvResultCode(String vResultCode) {
        this.vResultCode = vResultCode;
    }

    /**
     * orderIdVtwの取得
     * @return the orderIdVtw of String
     */
    public String getOrderIdVtw() {
        return orderIdVtw;
    }

    /**
     * orderIdVtwの設定
     * @param orderIdVtw the orderIdVtw to set
     */
    public void setOrderIdVtw(String orderIdVtw) {
        this.orderIdVtw = orderIdVtw;
    }

    /**
     * mStatusVtwの取得
     * @return the mStatusVtw of String
     */
    public String getmStatusVtw() {
        return mStatusVtw;
    }

    /**
     * mStatusVtwの設定
     * @param mStatusVtw the mStatusVtw to set
     */
    public void setmStatusVtw(String mStatusVtw) {
        this.mStatusVtw = mStatusVtw;
    }

    /**
     * vResultCodeVtwの取得
     * @return the vResultCodeVtw of String
     */
    public String getvResultCodeVtw() {
        return vResultCodeVtw;
    }

    /**
     * vResultCodeVtwの設定
     * @param vResultCodeVtw the vResultCodeVtw to set
     */
    public void setvResultCodeVtw(String vResultCodeVtw) {
        this.vResultCodeVtw = vResultCodeVtw;
    }

    /**
     * @param verifyOrderId セットする verifyOrderId
     */
    public void setVerifyOrderId(boolean verifyOrderId) {
        this.verifyOrderId = verifyOrderId;
    }

    /**
     * verifyOrderIdの取得
     * @return the verifyOrderId of String
     */
    public boolean getVerifyOrderId() {
        return verifyOrderId;
    }

    /**
     * @param verifyMStatus セットする verifyMStatus
     */
    public void setVerifyMStatus(boolean verifyMStatus) {
        this.verifyMStatus = verifyMStatus;
    }

    /**
     * verifyMStatusの取得
     * @return the verifyMStatus of String
     */
    public boolean getVerifyMStatus() {
        return verifyMStatus;
    }

    /**
     * @param verifyVResultCode セットする verifyVResultCode
     */
    public void setVerifyVResultCode(boolean verifyVResultCode) {
        this.verifyVResultCode = verifyVResultCode;
    }

    /**
     * verifyVResultCodeの取得
     * @return the verifyVResultCode of String
     */
    public boolean getVerifyVResultCode() {
        return verifyVResultCode;
    }

    /**
     * @param verifyError セットする verifyError
     */
    public void setVerifyError(boolean verifyError) {
        this.verifyError = verifyError;
    }

    /**
     * verifyErrorの取得
     * @return the verifyError of String
     */
    public boolean getVerifyError() {
        return verifyError;
    }
}
