package jp.co.veritrans.vtweb.sample.server.action.cvs;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import jp.co.veritrans.vtweb.mdk.common.Constants;
import jp.co.veritrans.vtweb.mdk.common.StringUtil;
import jp.co.veritrans.vtweb.sample.server.action.CommodityForm;

/**
 * コンビニ決済のActionFormクラス
 */
public class CvsForm extends CommodityForm {

    /**
     * serial version UID.
     */
    private static final long serialVersionUID = -2880416838093898748L;

    /**
     * ログ出力用インスタンス
     */
    private static Logger log = Logger.getLogger(CvsForm.class);

    /**
     * 有効な決済方法サブタイプを保持するArrayList
     */
    private static ArrayList subtype = new ArrayList();
    static {
        subtype.add(Constants.CVS_SUBTYPE_711);
        subtype.add(Constants.CVS_SUBTYPE_ECON);
        subtype.add(Constants.CVS_SUBTYPE_OTHER);
    }
    
    /**
     * コンストラクタ
     */
    public CvsForm() {
        super();
        setSettlementType(Constants.SETTLEMENT_TYPE_CVS);
    }

    /**
     * エラーチェック。厳密なチェックはVTWebで行うため、ここでは形式的なチェックのみでも問題ありませんが、
     * レスポンスタイム等を考慮し、必要に応じてチェック内容をご検討下さい。
     * 
     * @param mapping このインスタンスを選択するために使用するマッピング
     * @param request 処理中のHTTPリクエスト
     * @return エラーメッセージ
     */
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        log.info("コンビニ決済の決済情報をチェックします");

        ActionErrors errors = new ActionErrors();
        
        // 決済方法サブタイプ
        if(!StringUtil.isNullStr(getSettlementSubType()) && !subtype.contains(getSettlementSubType())){
            addError(errors, "error.cvs.subtype.invalid");
        }
        
        super.validate(mapping, request, errors);
        return errors;
    }
}
