package jp.co.veritrans.vtweb.sample.server.action.em;

import jp.co.veritrans.vtweb.mdk.common.Constants;
import jp.co.veritrans.vtweb.mdk.common.DateUtil;
import jp.co.veritrans.vtweb.mdk.common.StringUtil;
import jp.co.veritrans.vtweb.mdk.conf.MerchantConf;
import jp.co.veritrans.vtweb.sample.server.action.CommodityForm;
import jp.co.veritrans.vtweb.sample.server.action.ConfirmAction;

/**
 * 電子マネー決済のActionクラス
 */
public class EmAction extends ConfirmAction {
    protected void addInfomation(CommodityForm form) {
        MerchantConf info = MerchantConf.getInfo();
        // 電子マネー決済固有項目のセット
        String subType = form.getSettlementSubType();
        String tmp = null;
        if (StringUtil.isNullStr(subType)) {
            // Suica用画面タイトル
            tmp = info.getScreenTitle();
            if (!StringUtil.isNullStr(tmp)) {
                form.setScreenTitle(tmp);
            }

            // 支払取消期限。
            // WAON使用時のみ必要
            int cancelLimit = Constants.DEFAULT_CANCEL_LIMIT_DAYS;
            form.setTimelimitOfCancel(DateUtil.getDateYYYYMMDD(cancelLimit));
        } else if (Constants.EM_SUBTYPE_EDY_PC.equals(subType)) {
            // 支払期限は10日固定なのでセットしない
        } else if (Constants.EM_SUBTYPE_EDY_MOBILE.equals(subType)) {

            tmp = info.getShopName();
            if (!StringUtil.isNullStr(tmp)) {
                form.setShopName(tmp);
            }
        } else if (Constants.EM_SUBTYPE_SUICA_MOBILE.equals(subType) || Constants.EM_SUBTYPE_SUICA_PC.equals(subType)) {

            tmp = info.getScreenTitle();
            if (!StringUtil.isNullStr(tmp)) {
                form.setScreenTitle(tmp);
            }
        } else if (Constants.EM_SUBTYPE_WAON_PC.equals(subType) || Constants.EM_SUBTYPE_WAON_MOBILE.equals(subType)) {
            int cancelLimit = Constants.DEFAULT_CANCEL_LIMIT_DAYS;
            form.setTimelimitOfCancel(DateUtil.getDateYYYYMMDD(cancelLimit));
        }
    }
}
