package jp.co.veritrans.vtweb.sample.server.action.em;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import jp.co.veritrans.vtweb.mdk.common.Constants;
import jp.co.veritrans.vtweb.mdk.common.StringUtil;
import jp.co.veritrans.vtweb.sample.server.action.CommodityForm;

/**
 * 電子マネー決済のActionFormクラス
 */
public class EmForm extends CommodityForm {

    /**
     * serial version UID.
     */
    private static final long serialVersionUID = 325748511747830070L;

    /**
     * ログ出力用インスタンス
     */
    private static Logger log = Logger.getLogger(EmForm.class);

    /**
     * 有効な決済方法サブタイプを保持するArrayList
     */
    private static ArrayList subtype = new ArrayList();
    static {
        subtype.add(Constants.EM_SUBTYPE_EDY_MOBILE);
        subtype.add(Constants.EM_SUBTYPE_EDY_PC);
        subtype.add(Constants.EM_SUBTYPE_SUICA_MOBILE);
        subtype.add(Constants.EM_SUBTYPE_SUICA_PC);
        subtype.add(Constants.EM_SUBTYPE_WAON_MOBILE);
        subtype.add(Constants.EM_SUBTYPE_WAON_PC);
    }

    /**
     * コンストラクタ
     */
    public EmForm() {
        super();
        setSettlementType(Constants.SETTLEMENT_TYPE_EM);
    }

    /**
     * エラーチェック。厳密なチェックはVTWebで行うため、ここでは形式的なチェックのみでも問題ありませんが、
     * レスポンスタイム等を考慮し、必要に応じてチェック内容をご検討下さい。
     * 
     * @param mapping このインスタンスを選択するために使用するマッピング
     * @param request 処理中のHTTPリクエスト
     * @return エラーメッセージ
     */
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        log.info("電子マネーの決済情報をチェックします");
        ActionErrors errors = new ActionErrors();

        // 決済方法サブタイプ
        if(!StringUtil.isNullStr(getSettlementSubType()) && !subtype.contains(getSettlementSubType())){
            addError(errors, "error.em.subtype.invalid");    
        }

        super.validate(mapping, request, errors);
        return errors;
    }
}
