package jp.co.veritrans.vtweb.sample.server.action.oricosc;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import jp.co.veritrans.vtweb.mdk.common.Constants;
import jp.co.veritrans.vtweb.mdk.common.StringUtil;
import jp.co.veritrans.vtweb.sample.server.action.CommodityForm;

/**
 * ショッピングクレジット決済のActionFormクラス
 */
public class OricoscForm extends CommodityForm {

    /**
     * serial version UID.
     */
    private static final long serialVersionUID = 3158369900801526001L;

    /**
     * ログ出力用インスタンス
     */
    private static Logger log = Logger.getLogger(OricoscForm.class);

    /**
     * コンストラクタ
     */
    public OricoscForm() {
        super();
        setSettlementType(Constants.SETTLEMENT_TYPE_ORICOSC);
    }

    /**
     * エラーチェック。厳密なチェックはVTWebで行うため、ここでは形式的なチェックのみでも問題ありませんが、
     * レスポンスタイム等を考慮し、必要に応じてチェック内容をご検討下さい。
     * 
     * @param mapping このインスタンスを選択するために使用するマッピング
     * @param request 処理中のHTTPリクエスト
     * @return エラーメッセージ
     */
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        log.info("ショッピングクレジットの決済情報をチェックします");
        ActionErrors errors = new ActionErrors();

        // 配送先郵便番号
        if (StringUtil.isNullStr(getShippingZipCode())) {
            addError(errors, "error.shippingZipCode.notset");
        }
        
        super.validate(mapping, request, errors);
        return errors;
    }
}
