package jp.co.veritrans.vtweb.sample.server.action.va;

import javax.servlet.http.HttpServletRequest;

import jp.co.veritrans.vtweb.mdk.common.Constants;
import jp.co.veritrans.vtweb.mdk.common.StringUtil;
import jp.co.veritrans.vtweb.sample.server.action.CommodityForm;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

/**
 * 銀行振込決済のActionFormクラス
 */
public class VaForm extends CommodityForm {

    /**
     * serial version UID.
     */
    private static final long serialVersionUID = -2811963429894680079L;

    /**
     * ログ出力用インスタンス
     */
    private static Logger log = Logger.getLogger(VaForm.class);

    /**
     * コンストラクタ
     */
    public VaForm() {
        super();
        setSettlementType(Constants.SETTLEMENT_TYPE_VA);
    }

    /**
     * エラーチェック。厳密なチェックはVTWebで行うため、ここでは形式的なチェックのみでも問題ありませんが、
     * レスポンスタイム等を考慮し、必要に応じてチェック内容をご検討下さい。
     *
     * @param mapping このインスタンスを選択するために使用するマッピング
     * @param request 処理中のHTTPリクエスト
     * @return エラーメッセージ
     */
    @Override
    public ActionErrors validate(final ActionMapping mapping, final HttpServletRequest request) {
        log.info("銀行振込決済の決済情報をチェックします");

        ActionErrors errors = new ActionErrors();

        // 支店コード
        if (!StringUtil.isNullStr(getBranchCode()) && !StringUtil.isSingleByteNumeric(getBranchCode())) {
            addError(errors, "error.branchCode.invalid");
        }

        // 口座番号
        if (!StringUtil.isNullStr(getAccountNumber()) && !StringUtil.isSingleByteNumeric(getAccountNumber())) {
            addError(errors, "error.accountNumber.invalid");
        }

        super.validate(mapping, request, errors);
        return errors;
    }
}
